=== debian/changelog ===
yder (1.4.11-1) unstable; urgency=medium

  * New upstream release
  * d/rules: avoid downloading dependencies if not found
  * d/patches: disable doc patch
  * d/copyright: update copyright

 -- Nicolas Mora <babelouest@debian.org>  Wed, 08 Jul 2020 23:24:58 -0400

yder (1.4.10-5) unstable; urgency=medium

  * d/control: use debhelper-compat
  * d/control: set debhelper-control version to 13
  * d/tests/control: cleanup test builder
  * d/control: Add Rules-Requires-Root field

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 28 Jun 2020 20:37:08 -0400

yder (1.4.10-4) unstable; urgency=medium

  * Upload to unstable
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 27 Jun 2020 11:41:21 -0400

yder (1.4.10-3) experimental; urgency=medium

  * d/rules: build documentation using doxygen
  * d/libyder-dev.docs: install documentation
  * d/copyright: fix maintainer e-mail address

 -- Nicolas Mora <nicolas@babelouest.org>  Fri, 03 Apr 2020 17:17:43 -0400

yder (1.4.10-2) experimental; urgency=medium

  * debian/control: specify orcania version
  * debian/control: ugrade compat version to 12

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 31 Mar 2020 21:19:34 -0400

yder (1.4.10-1) experimental; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.5.0 (no changes)
  * debian/copyright: update forgotten copyright mention

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 28 Mar 2020 08:34:18 -0400
