=== debian/control ===
Source: yder
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
          , Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
	, autopkgtest (>= 5.6~)
	, dh-exec
	, liborcania-dev
	, libsystemd-dev [linux-any]
	, cmake
	, check
	, doxygen
Standards-Version: 4.5.0
Homepage: https://github.com/babelouest/yder
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/yder.git
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/yder.git
Rules-Requires-Root: no

Package: libyder2.0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: logging library written in C
 Simple and easy to use logging library. You can log messages to the
 console, a file or syslog.
 .
 Yder is mono-thread, which mean that you can use only one instance
 of yder log at the same time in your program.

Package: libyder-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libyder2.0 (= ${binary:Version})
	, ${misc:Depends}
	, liborcania-dev
	, libsystemd-dev [linux-any]
Description: logging library written in C - development
 Simple and easy to use logging library. You can log messages to the
 console, a file or syslog.
 .
 Yder is mono-thread, which mean that you can use only one instance
 of yder log at the same time in your program.
 .
 This package contains the development files.
