=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

ifneq ($(DEB_HOST_ARCH_OS),linux)
ARGS += -DWITH_JOURNALD=OFF
else
ARGS += -DWITH_JOURNALD=ON
endif

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_install:
	echo dh_auto_install

override_dh_auto_configure:
	dh_auto_configure -- $(ARGS) -DBUILD_YDER_TESTING=ON \
                               -DINSTALL_HEADER=ON \
                               -DDOWNLOAD_DEPENDENCIES=OFF \
                               --no-warn-unused-cli
	dh_installexamples --

override_dh_auto_build:
	doxygen doc/doxygen.cfg
	dh_auto_build --
