=== src/Makefile ===
--- 
+++ 
@@ -35,7 +35,7 @@
 OUTPUT=libyder.so
 VERSION_MAJOR=1
 VERSION_MINOR=4
-VERSION_PATCH=11
+VERSION_PATCH=12
 
 SONAME = -soname
 ifeq ($(shell uname -s),Darwin)
