=== debian/changelog ===
yder (1.4.12-1) unstable; urgency=medium

  * d/control: Remove dh-exec from builddep
  * d/rules: enable dh_install
  * d/*.install: Do not use dh-exec

 -- Nicolas Mora <babelouest@debian.org>  Thu, 03 Sep 2020 07:51:17 -0400
