=== debian/control ===
--- 
+++ 
@@ -6,7 +6,6 @@
           , Nicolas Mora <babelouest@debian.org>
 Build-Depends: debhelper-compat (= 13)
 	, autopkgtest (>= 5.6~)
-	, dh-exec
 	, liborcania-dev
 	, libsystemd-dev [linux-any]
 	, cmake
