=== debian/changelog ===
yder (1.4.14-1ubuntu2) impish; urgency=medium

  * Back in sync with Debian

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 05 Oct 2021 08:50:55 +0200

yder (1.4.14-1) unstable; urgency=medium

  * New upstream release
  * d/control: upgrade standards version to 4.6.0
  * d/copyright: remove superfluous file

 -- Nicolas Mora <babelouest@debian.org>  Wed, 15 Sep 2021 07:19:10 -0400
