=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 	, cmake
 	, check
 	, doxygen
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://github.com/babelouest/yder
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/yder.git
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/yder.git
