=== debian/changelog ===
yder (1.4.17-1) unstable; urgency=medium

  * New upstream release
  * d/symbols: Add symbol y_set_split_message_newline

 -- Nicolas Mora <babelouest@debian.org>  Wed, 01 Jun 2022 19:00:28 -0400

yder (1.4.15-2) unstable; urgency=medium

  * d/control: Add version required for liborcania

 -- Nicolas Mora <babelouest@debian.org>  Mon, 18 Apr 2022 16:49:03 -0400

yder (1.4.15-1) unstable; urgency=medium

  * New upstream release
  * d/copyright: update years
  * d/not-installed: do not install .gitignore files

 -- Nicolas Mora <babelouest@debian.org>  Mon, 11 Apr 2022 19:54:45 -0400
