=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
           , Nicolas Mora <babelouest@debian.org>
 Build-Depends: debhelper-compat (= 13)
 	, autopkgtest (>= 5.6~)
-	, liborcania-dev
+	, liborcania-dev (>= 2.2.2)
 	, libsystemd-dev [linux-any]
 	, cmake
 	, check
@@ -35,7 +35,7 @@
 Section: libdevel
 Depends: libyder2.0 (= ${binary:Version})
 	, ${misc:Depends}
-	, liborcania-dev
+	, liborcania-dev (>= 2.2.2)
 	, libsystemd-dev [linux-any]
 Description: logging library written in C - development
  Simple and easy to use logging library. You can log messages to the
