=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # Makefile used to build all programs
 #
-# Copyright 2014-2020 Nicolas Mora <mail@babelouest.org>
+# Copyright 2014-2022 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public License
@@ -35,6 +35,7 @@
 	cd $(LIBYDER_LOCATION) && $(MAKE) clean
 	cd $(EXAMPLE_LOCATION) && $(MAKE) clean
 	cd $(TEST_LOCATION) && $(MAKE) clean
+	rm -rf doc/html/
 
 check:
 	cd $(TEST_LOCATION) && $(MAKE) test
