=== debian/changelog ===
yder (1.4.19-1) unstable; urgency=medium

  [Nicolas Mora]
  * New upstream release
  * d/control: Update Standards-Version to 4.6.2
  * d/libyder-dev.install: Add cmake dependencies
  * d/copyright: Update copyright year to 2023 for debian/* files

  [Debian Janitor]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on autopkgtest.

 -- Nicolas Mora <babelouest@debian.org>  Sun, 08 Jan 2023 09:39:56 -0500

yder (1.4.18-1) unstable; urgency=medium

  * New upstream release
  * d/control: upgrade standards version to 4.6.1

 -- Nicolas Mora <babelouest@debian.org>  Sat, 15 Oct 2022 17:13:51 -0400
