=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
           , Nicolas Mora <babelouest@debian.org>
 Build-Depends: debhelper-compat (= 13)
-	, autopkgtest (>= 5.6~)
+	, autopkgtest
 	, liborcania-dev (>= 2.2.2)
 	, libsystemd-dev [linux-any]
 	, cmake
 	, check
 	, doxygen
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/babelouest/yder
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/yder.git
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/yder.git
