=== debian/rules ===
--- 
+++ 
@@ -23,15 +23,13 @@
 %:
 	dh $@ --buildsystem=cmake --builddirectory=build
 
-override_dh_auto_install:
-	echo dh_auto_install
-
 override_dh_auto_configure:
-	dh_auto_configure -- $(ARGS) -DBUILD_YDER_TESTING=ON \
-                               -DINSTALL_HEADER=ON \
-                               -DDOWNLOAD_DEPENDENCIES=OFF \
-                               --no-warn-unused-cli
-	dh_installexamples --
+	dh_auto_configure -- $(ARGS) \
+						-DSKIP_BUILD_RPATH=TRUE \
+						-DBUILD_YDER_TESTING=ON \
+						-DINSTALL_HEADER=ON \
+						-DDOWNLOAD_DEPENDENCIES=OFF \
+						--no-warn-unused-cli
 
 override_dh_auto_build:
 	doxygen doc/doxygen.cfg
